import {NgModule} from "@angular/core";
import {SolidifyValidationDirective} from "./directives/validation/solidify-validation.directive";
import {isPipes} from "./pipes/shared-is-pipes/is-pipes.model";

const routables = [];
const containers = [];
const presentationals = [];
const directives = [
  SolidifyValidationDirective,
];
const pipes = [
  ...isPipes,
];
const modules = [];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...presentationals,
    ...directives,
    ...pipes,
  ],
  entryComponents: [],
  imports: [
    ...modules,
  ],
  exports: [
    ...routables,
    ...containers,
    ...presentationals,
    ...directives,
    ...pipes,
    ...modules,
  ],
  providers: [],
})
export class SolidifyFrontendModule {
}
