import {RoutesEnum} from "../../enums";
import {BaseOptions} from "../base/base-options.model";
import {ResourceNameSpace} from "./resource-namespace.model";

export interface ResourceOptions extends BaseOptions {
  nameSpace: ResourceNameSpace;
  routeRedirectUrlAfterSuccessCreateAction?: RoutesEnum | undefined | ((resId: string) => string);
  routeRedirectUrlAfterSuccessUpdateAction?: RoutesEnum | undefined | ((resId: string) => string);
  routeRedirectUrlAfterSuccessDeleteAction?: RoutesEnum | undefined | ((resId: string) => string);
  notificationResourceCreateTextToTranslate?: string;
  notificationResourceUpdateTextToTranslate?: string;
  notificationResourceDeleteTextToTranslate?: string;
  keepCurrentStateBeforeCreate?: boolean;
  keepCurrentStateAfterCreate?: boolean;
  keepCurrentStateAfterUpdate?: boolean;
  keepCurrentStateAfterDelete?: boolean;
}
