import {ChangeCase} from "../lib-wrapped/change-case.model";
import {KeyValue} from "../models/query-parameters/key-value.model";

export class StringUtil {
  static readonly stringEmpty: string = "";

  static format(str: string, ...val: string[]): string {
    for (let i = 0; i < val.length; i++) {
      str = str.replace(`{${i}}`, val[i]);
    }
    return str;
  }

  static formatKeyValue(str: string, ...val: KeyValue[]): string {
    val.forEach(v => {
      str = str.replace(`{${v.key}}`, v.value);
    });
    return str;
  }

  static convertSpinalCaseToPascalCase(origin: string): string {
    origin = origin.replace("-", " ");
    return ChangeCase.pascalCase(origin);
  }

  static convertSpinalCaseToCamelCase(origin: string): string {
    origin = origin.replace("-", " ");
    return ChangeCase.camelCase(origin);
  }

  static convertToPascalCase(origin: string): string {
    return ChangeCase.pascalCase(origin);
  }
}
